#include <cmath>
#include "AABB.h"

AABB::AABB(double oX, double oY, double w, double h)
	: oX(oX), oY(oY), w(w), h(h)
{
}

AABB::~AABB(void)
{
}

void AABB::SetPosition(double new_oX, double new_oY)
{
	oX = new_oX;
	oY = new_oY;
}

void AABB::SetWidth(double new_w)
{
	w = new_w;
}

void AABB::SetHeight(double new_h)
{
	h = new_h;
}

bool Collision(AABB* pRect1, AABB* pRect2)
{
	double offsetX1 = pRect1->oX - pRect1->w/2.;
	double offsetY1 = pRect1->oY - pRect1->h/2.;
	double offsetX2 = pRect2->oX - pRect2->w/2.;
	double offsetY2 = pRect2->oY - pRect2->h/2.;
	return !(offsetX1 > offsetX2 + pRect2->w
		  || offsetY1 > offsetY2 + pRect2->h
		  || offsetX2 > offsetX1 + pRect1->w
		  || offsetY2 > offsetY1 + pRect1->h);
}
