#include "Game.h"


Game::Game(void)
{
}


Game::~Game(void)
{
}

void Game::Play(sf::RenderWindow &window)
{
	// Variables temps
	sf::Clock MoveClock, FPSRefreshClock;
	float MoveTimeFactor;

	// Cration de la tilemap
	sf::Image imgTileset;
	imgTileset.LoadFromFile("img/tileset.bmp");
	TileMap tilemap(imgTileset);

	// Cration des Tank
	sf::Texture texTank1;
	texTank1.LoadFromFile("img/tank_V.png");
	sf::Texture texTank2;
	texTank2.LoadFromFile("img/tank_B.png");
	sf::Texture texBomb;
	texBomb.LoadFromFile("img/bomb.png");
	Tank Tank1(texTank1, texBomb, tilemap.GetTank1_InitPos(), tilemap); // Flches + numpad 0
	Tank Tank2(texTank2, texBomb, tilemap.GetTank2_InitPos(), tilemap); // ZQSD + Espace

	// Cration du HUD (affichage tte haute)
	sf::Font font;
	font.LoadFromFile("img/HUD.ttf");

	sf::Text FPS("0", font, 50U);
	FPS.SetPosition(SCREEN_WIDTH - FPS.GetGlobalBounds().Width - 2, SCREEN_HEIGHT - (FPS.GetGlobalBounds().Height + 2) - 28);
	FPS.SetColor(sf::Color::Green);
	char tmpFPS[21] = "0";

	char tmpLifeT1[21] = "0";
	int lastLifeT1 = Tank1.GetLife();
	sprintf_s(tmpLifeT1, "%d", lastLifeT1);
	sf::Text ScoreT1(tmpLifeT1, font, 50U);
	ScoreT1.SetPosition(2, - 28);
	ScoreT1.SetColor(sf::Color::Yellow);
	sf::Sprite AvailableBomb1T1(texBomb);
	AvailableBomb1T1.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));
	AvailableBomb1T1.SetOrigin(static_cast<float>(BOMB_W), static_cast<float>(BOMB_MH / 2));
	AvailableBomb1T1.SetPosition(ScoreT1.GetGlobalBounds().Width + 10 + 2, BOMB_MH + 12);
	AvailableBomb1T1.Rotate(90);
	AvailableBomb1T1.Scale(2.f, 2.f);
	sf::Sprite AvailableBomb2T1(texBomb);
	AvailableBomb2T1.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));
	AvailableBomb2T1.SetOrigin(static_cast<float>(BOMB_W), static_cast<float>(BOMB_MH / 2));
	AvailableBomb2T1.SetPosition(ScoreT1.GetGlobalBounds().Width + 25 + 2, BOMB_MH + 12);
	AvailableBomb2T1.Rotate(90);
	AvailableBomb2T1.Scale(2.f, 2.f);

	char tmpLifeT2[21] = "0";
	int lastLifeT2 = Tank2.GetLife();
	sprintf_s(tmpLifeT2, "%d", lastLifeT2);
	sf::Text ScoreT2(tmpLifeT2, font, 50U);
	ScoreT2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 2), - 28);
	ScoreT2.SetColor(sf::Color(0, 255, 255));
	sf::Sprite AvailableBomb1T2(texBomb);
	AvailableBomb1T2.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));
	AvailableBomb1T2.SetOrigin(static_cast<float>(BOMB_W), static_cast<float>(BOMB_MH / 2));
	AvailableBomb1T2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 10 + 2), BOMB_MH + 12);
	AvailableBomb1T2.Rotate(90);
	AvailableBomb1T2.Scale(2.f, 2.f);
	sf::Sprite AvailableBomb2T2(texBomb);
	AvailableBomb2T2.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));
	AvailableBomb2T2.SetOrigin(static_cast<float>(BOMB_W), static_cast<float>(BOMB_MH / 2));
	AvailableBomb2T2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 25 + 2), BOMB_MH + 12);
	AvailableBomb2T2.Rotate(90);
	AvailableBomb2T2.Scale(2.f, 2.f);

	// Excution de la boucle principale
	while (window.IsOpened())
	{
		//---------------------------------------------------------------------------------------------------
		// Traitement des vnements
		sf::Event Event;
		while (window.PollEvent(Event))
		{
			// Fentre ferme : on quitte
			if (Event.Type == sf::Event::Closed || ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Escape)))
				return;

			// Espace : Le tank 1 tire une bombe
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Space))
				Tank1.ThrowBomb();
			// Numpad 0 : Le tank 2 tire une bombe
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Numpad0))
				Tank2.ThrowBomb();
		}
		//---------------------------------------------------------------------------------------------------
		// Gestion des touches du jeu

		/* Dplacements */

		// Rcupre le temps pass depuis le dernier tour de boucle -> pour le dplacement
		MoveTimeFactor = MoveClock.GetElapsedTime() / 1000.f;
		MoveClock.Reset();

		// Rotation Tank 1
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Q))
			Tank1.TurnLeft(MoveTimeFactor, Tank2);
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::D))
			Tank1.TurnRight(MoveTimeFactor, Tank2);

		// Rotation Tank 2
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Left))
			Tank2.TurnLeft(MoveTimeFactor, Tank1);
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Right))
			Tank2.TurnRight(MoveTimeFactor, Tank1);

		// Dplacement Tank 1
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Z))
			Tank1.MoveForw(MoveTimeFactor, Tank2);
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::S))
			Tank1.MoveBckw(MoveTimeFactor, Tank2);

		// Dplacement Tank 2
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Up))
			Tank2.MoveForw(MoveTimeFactor, Tank1);
		if (sf::Keyboard::IsKeyPressed(sf::Keyboard::Down))
			Tank2.MoveBckw(MoveTimeFactor, Tank1);

		//---------------------------------------------------------------------------------------------------
		// Mise  jour des tanks et des bombes
		Tank1.UpdateAnim();
		Tank2.UpdateAnim();
		Tank1.UpdateBombs(MoveTimeFactor, Tank2);
		Tank2.UpdateBombs(MoveTimeFactor, Tank1);

		//---------------------------------------------------------------------------------------------------
		// Mets  jour le HUD

		// Calcul des FPS (images par seconde)
		if (FPSRefreshClock.GetElapsedTime() / 1000.f >= 0.2f)
		{
			sprintf_s(tmpFPS, "%f", 1000.f / window.GetFrameTime());
			FPS.SetString(tmpFPS);
			FPS.SetPosition(SCREEN_WIDTH - FPS.GetGlobalBounds().Width - 2, SCREEN_HEIGHT - (FPS.GetGlobalBounds().Height + 2)  - 28);
			FPSRefreshClock.Reset();
		}

		// Changement de la vie du Tank 1 dans le HUD
		if (lastLifeT1 != Tank1.GetLife())
		{
			lastLifeT1 = Tank1.GetLife();
			sprintf_s(tmpLifeT1, "%d", lastLifeT1);
			ScoreT1.SetString(tmpLifeT1);
			AvailableBomb1T1.SetPosition(ScoreT1.GetGlobalBounds().Width + 10 + 2, BOMB_MH + 12);
			AvailableBomb2T1.SetPosition(ScoreT1.GetGlobalBounds().Width + 25 + 2, BOMB_MH + 12);
		}

		// Changement de la vie du Tank 2 dans le HUD
		if (lastLifeT2 != Tank2.GetLife())
		{
			lastLifeT2 = Tank2.GetLife();
			sprintf_s(tmpLifeT2, "%d", lastLifeT2);
			ScoreT2.SetString(tmpLifeT2);
			ScoreT2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 2), - 28);
			AvailableBomb1T2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 10 + 2), BOMB_MH + 12);
			AvailableBomb2T2.SetPosition(SCREEN_WIDTH - (ScoreT2.GetGlobalBounds().Width + 25 + 2), BOMB_MH + 12);
		}

		// Anime les bombes du Tank 1 du HUD
		if (Tank1.GetBombStack().size() >= 2)
			AvailableBomb1T1.SetTextureRect(sf::IntRect(Tank1.GetBombStack().at(1).m_currentFrame * BOMB_W, 0, BOMB_W, BOMB_MH));
		else AvailableBomb1T1.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));

		if (Tank1.GetBombStack().size() >= 1)
			AvailableBomb2T1.SetTextureRect(sf::IntRect(Tank1.GetBombStack().at(0).m_currentFrame * BOMB_W, 0, BOMB_W, BOMB_MH));
		else AvailableBomb2T1.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));

		// Anime les bombes du Tank 2 du HUD
		if (Tank2.GetBombStack().size() >= 2)
			AvailableBomb1T2.SetTextureRect(sf::IntRect(Tank2.GetBombStack().at(1).m_currentFrame * BOMB_W, 0, BOMB_W, BOMB_MH));
		else AvailableBomb1T2.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));

		if (Tank2.GetBombStack().size() >= 1)
			AvailableBomb2T2.SetTextureRect(sf::IntRect(Tank2.GetBombStack().at(0).m_currentFrame * BOMB_W, 0, BOMB_W, BOMB_MH));
		else AvailableBomb2T2.SetTextureRect(sf::IntRect(0, 0, BOMB_W, BOMB_MH));

		//---------------------------------------------------------------------------------------------------
		// Efface l'cran (remplissage avec du blanc)
		window.Clear(sf::Color::White);

		// Affichage du tilemap
		tilemap.Draw(window);

		// Affichage du Tank et des missiles
		window.Draw(Tank1);
		window.Draw(Tank2);
		Tank1.DrawBombs(window);
		Tank2.DrawBombs(window);

		// Affichage du HUD
		window.Draw(FPS);
		window.Draw(ScoreT1);
		if (Tank1.GetBombStack().size() < 2) window.Draw(AvailableBomb1T1); // Munitions restantes du tank 1
		if (Tank1.GetBombStack().size() < 1) window.Draw(AvailableBomb2T1);
		window.Draw(ScoreT2);
		if (Tank2.GetBombStack().size() < 2) window.Draw(AvailableBomb1T2); // Munitions restantes du tank 2
		if (Tank2.GetBombStack().size() < 1) window.Draw(AvailableBomb2T2);

		// Affichage du contenu de la fentre  l'cran
		window.Display();
	}
}

