#include "ImgAnim.h"


ImgAnim::ImgAnim(sf::Texture* texture, int w, int h, bool play, float interval)
	: m_texture(texture),
	sf::Sprite(*m_texture),
	m_isPlaying(play),
	m_currentRow(0),
	m_currentFrame(0),
	m_interval(interval),
	m_frameWidth(w),
	m_frameHeight(h)
{
	// Calcule le nb de colones et de frames
	m_nbRow = m_texture->GetHeight() / m_frameHeight;
	m_nbFrames = m_texture->GetWidth() / m_frameWidth;
}

ImgAnim::~ImgAnim(void)
{
}

void ImgAnim::Play()
{
	m_isPlaying = true;
}

void ImgAnim::Restart()
{
	m_isPlaying = true;
	m_currentFrame = 0;
}

void ImgAnim::Pause()
{
	m_isPlaying = false;
}

void ImgAnim::SetRow(int row)
{
	// Pas de vrification car l'utilisateur peut la faire lui mme, et peut avoir ses raisons de faire n'importe quoi ;)
	m_currentRow = row;
	m_currentFrame = 0;
}

void ImgAnim::SetFrame(int frame)
{
	// Pas de vrification car l'utilisateur peut la faire lui mme, et peut avoir ses raisons de faire n'importe quoi ;)
	m_currentFrame = frame;
}

void ImgAnim::SetInterval(float interval)
{
	m_interval = interval;
}

void ImgAnim::UpdateAnim()
{
	// Toutes les 0.2 secondes, l'anim du tank bouge
	if (m_isPlaying && m_animClock.GetElapsedTime() / 1000.f >= m_interval)
	{
		m_animClock.Reset();

		// Bouge l'image
		if (++m_currentFrame >= m_nbFrames)
			m_currentFrame = 0;
	}
	SetTextureRect(sf::IntRect(m_currentFrame * m_frameWidth, m_currentRow * m_frameHeight, m_frameWidth, m_frameHeight));
}

void ImgAnim::SetAnimTexture(sf::Texture *texture)
{
	m_texture = texture;
	sf::Sprite::SetTexture(*m_texture);

	// Calcule le nb de colones et de frames
	m_nbRow = m_texture->GetHeight() / m_frameHeight;
	m_nbFrames = m_texture->GetWidth() / m_frameWidth;

	UpdateAnim();
}