#pragma once
#include <SFML\Graphics.hpp>

class ImgAnim : public sf::Sprite
{
public:
	ImgAnim(sf::Texture* texture, int w, int h, bool play = false, float interval = 0.1f);
	virtual ~ImgAnim(void);

	void Play();
	void Pause();
	void Restart();
	void SetRow(int row);
	void SetFrame(int frame);
	void SetInterval(float interval);

	void UpdateAnim();

	void SetAnimTexture(sf::Texture* texture);

	int IsPlaying() const { return m_isPlaying; }
	int GetFrameWidth() const { return m_frameWidth; }
	int GetFrameHeight() const { return m_frameHeight; }
	int GetNbRow() const { return m_nbRow; }
	int GetNbFrames() const { return m_nbFrames; }
	int GetCurrentRow() const { return m_currentRow; }
	int GetCurrentFrame() const { return m_currentFrame; }

private:
	int m_frameWidth;
	int m_frameHeight;
	int m_nbRow;
	int m_nbFrames;
	int m_currentRow;
	float m_interval;
	bool m_isPlaying;
	int m_currentFrame;
	sf::Clock m_animClock;
	sf::Texture *m_texture;
};

