#pragma once
#include <SFML\Graphics.hpp>
#include "Defines.h"
#include "ImgAnim.h"
#include "AABB.h"

class Tile : public ImgAnim
	{
	public:
		Tile(sf::Texture *texture);
		virtual ~Tile(void);
		
		virtual void SetLife(int life);
		int GetLife() const { return m_life; }
		
		bool IsBlocking() const { return m_isBlocking; }
		void SetBlocking(bool b) { m_isBlocking = b; }
		bool IsHoverable() const { return m_isHoverable; }
		void SetHoverable(bool h) { m_isHoverable = h; }
		bool IsBreakable() const { return m_isBreakable; }
		void SetBreakable(bool b) { m_isBreakable = b; }

		const AABB& GetAABB() const { return m_AABB; }

	private:
		bool m_isBlocking; // Si le tank peut passer par dessus
		bool m_isBreakable; // Si la tile est destructible
		bool m_isHoverable; // Si les bombes peuvent le survoler
		
		AABB m_AABB;
		int m_life;
	};