#pragma once
#include <iostream>
#include <SFML\Graphics.hpp>
#include <string>
#include <vector>
#include "Tile.h"

class TileMap
{
public:
	TileMap(const sf::Image &tilemap);
	virtual ~TileMap(void);

	void UpdateAnims();
	void UpdateTiles();
	void UpdateTexture();
	void Draw(sf::RenderTarget& target);

	void SetTileLife(int i, int j, int life);
	void AddToTileLife(int i, int j, int life);

	unsigned int GetNbRow() const { return m_nbRows; }
	unsigned int GetNbColumns() const { return m_nbColumns; }
	sf::Vector2f GetTank1_InitPos() const { return m_tank1_initPos; }
	sf::Vector2f GetTank2_InitPos() const { return m_tank2_initPos; }
	const std::vector< std::vector<Tile> >& GetMap() const { return m_map; }

private:
	sf::Vector2f m_tank1_initPos;
	sf::Vector2f m_tank2_initPos;

	unsigned int m_nbRows;
	unsigned int m_nbColumns;
	std::vector< std::vector<Tile> > m_map;

	const sf::Image &m_tilemap;

	sf::RenderTexture m_renderTexture;
	bool m_needTextureUpdate;

	std::vector<sf::Texture> m_textures;
};