#include <SFML/Graphics.hpp>
#include <iostream>
#include <vector>
#include "Defines.h"
#include "Game.h"

int main()
{
	// Cration de la fentre de rendu
	sf::RenderWindow App(sf::VideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, 32), "Galaxy Games - Tanks");
	App.SetFramerateLimit(60);

	// Cration du HUD (affichage tte haute)
	sf::Font font;
	font.LoadFromFile("img/HUD.ttf");

	sf::Text txtTitre("Galaxy Games - Tanks", font, 65U);
	txtTitre.SetStyle(sf::Text::Style::Bold);
	txtTitre.SetPosition(SCREEN_WIDTH / 2 - txtTitre.GetGlobalBounds().Width / 2.f, 50.f);
	txtTitre.SetColor(sf::Color(57, 95, 255));

	std::vector<sf::Text> choix;
	choix.push_back(sf::Text("Jouer  deux", font, 50U));
	choix.push_back(sf::Text("Jouer en rseau", font, 50U));
	choix.push_back(sf::Text("Aide", font, 50U));
	choix.push_back(sf::Text("Quitter", font, 50U));

	for (unsigned int i = 0; i < choix.size(); ++i)
	{
		choix.at(i).SetPosition(static_cast<float>(SCREEN_WIDTH / 2 - choix.at(i).GetGlobalBounds().Width / 2), 
								static_cast<float>(SCREEN_HEIGHT / 2 - (choix.size() - i) * 56));
		choix.at(i).SetStyle(sf::Text::Style::Bold);
	}

	sf::Texture texFond;
	texFond.LoadFromFile("img/ground.jpg");
	sf::Sprite spriteFond(texFond);

	// Variables du menu
	unsigned int current = 0;

	// Excution de la boucle principale
	while (App.IsOpened())
	{
		// Traitement des vnements
		sf::Event Event;
		while (App.PollEvent(Event))
		{
			// Fentre ferme : on quitte
			if (Event.Type == sf::Event::Closed || ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Escape)))
				App.Close();

			// Flche haut
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Up))
				if (--current < 0)
					current = choix.size() - 1;

			// Flche bas
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Down))
				if (++current >= choix.size())
					current = 0;

			// Touche Entre
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Keyboard::Return))
			{
				if (choix.at(current).GetString() == "Jouer  deux")
					Game::Play(App);
				else if (choix.at(current).GetString() == "Quitter")
					App.Close();
			}
		}

		// Change les couleurs des choix
		for (unsigned int i = 0; i < choix.size(); ++i)
		{
			if (current == i) // Courent
				choix.at(i).SetColor(sf::Color(0, 160, 226));
			else
				choix.at(i).SetColor(sf::Color(0, 113, 167));
		}

		// Efface l'cran (remplissage avec du blanc)
		App.Clear(sf::Color::White);

		// Affichage du fond
		for (unsigned int i = 0; i < App.GetWidth() / texFond.GetWidth() + 1; ++i)
		{
			for (unsigned int j = 0; j < App.GetHeight() / texFond.GetHeight() + 1; ++j)
			{
				spriteFond.SetPosition(static_cast<float>(i * texFond.GetWidth()), static_cast<float>(j * texFond.GetHeight()));
				App.Draw(spriteFond);
			}
		}

		// Affichage du titre et des options
		App.Draw(txtTitre);
		for (unsigned int i = 0; i < choix.size(); ++i)
			App.Draw(choix.at(i));

		// Affichage du contenu de la fentre  l'cran
		App.Display();
	}
	return EXIT_SUCCESS;
}